'***********************************************************************
'*                                                                     *
'*   Licensed Materials - Properity of IBM                             *
'*                                                                     *
'*   "Restricted Materials of IBM"                                     *
'*                                                                     *
'*   5621-290, 57-270, 5622-615,5765-468, 5697-216                     *
'*                                                                     *
'*   Copyright IBM Corp. 1993, 1996  All Rights Reserved.              *
'*                                                                     *
'*   Us Government Users Restricted Rights - Use, duplication or       *
'*   disclosure restricted by GSA ADP Schedule Contract with           *
'*   IBM Corp.                                                         *
'*                                                                     *
'***********************************************************************
'***********************************************************************
'*                                                                     *
'* Container API and Process API                                       *
'*                                                                     *
'***********************************************************************
'-----------------------------------------------------------------------
' Constants
'-----------------------------------------------------------------------

' Container type
Global Const EXMPJ_INPUT_CTNR = 0
Global Const EXMPJ_OUTPUT_CTNR = 1

' Container data types
Global Const EXMPJ_TYPE_LONG = 0
Global Const EXMPJ_TYPE_STRING = 1
Global Const EXMPJ_TYPE_FLOAT = 2

' Operation modes for process API
Global Const EXMPJ_API_MODE_CURRENT = 0
Global Const EXMPJ_API_MODE_ALL = 1
Global Const EXMPJ_API_MODE_QUERY = 2

' Operation modes for activity API
Global Const EXMPJ_ACT_START = 0
Global Const EXMPJ_ACT_RESTART = 1
Global Const EXMPJ_ACT_FINISH = 2
Global Const EXMPJ_ACT_FINISH_IF_READY = 3
Global Const EXMPJ_ACT_FINISH_IF_RUNNING = 4

' Activity states
Global Const EXMPJ_ACT_STATE_IDLE = 1        ' activity was idle
Global Const EXMPJ_ACT_STATE_READY = 2       ' activity was ready
Global Const EXMPJ_ACT_STATE_RUNNING = 3     ' activity was running
Global Const EXMPJ_ACT_STATE_FINISHED = 4    ' activity was finished
Global Const EXMPJ_ACT_STATE_SKIPPED = 5     ' activity was skipped
Global Const EXMPJ_ACT_STATE_SUSPENDED = 6   ' activity was suspended
Global Const EXMPJ_ACT_STATE_TERMINATED = 7  ' activity was terminated
Global Const EXMPJ_ACT_STATE_DISABLED = 8    ' activity was disabled

' Definitions for new logon
Global Const EXMPJ_NODEID_LOCAL = "LOCAL"

Global Const EXMPJ_PROTOCOL_LOC = "LOC"
Global Const EXMPJ_PROTOCOL_SNA = "SNA"
Global Const EXMPJ_PROTOCOL_TCI = "TCI"
Global Const EXMPJ_PROTOCOL_NBI = "NBI"

' Length of string parameters
Global Const EXMPJ_SESS_BUF_LEN = 20

Global Const EXMPJ_MAX_PROCESS_NAME_LEN = 43
Global Const EXMPJ_MAX_CLONE_NAME_LEN = 54

Global Const EXMPJ_MAX_USER_ID_LEN = 32
Global Const EXMPJ_MAX_PASSWORD_LEN = 32
Global Const EXMPJ_MAX_DATABASE_LEN = 8
Global Const EXMPJ_MAX_SERVER_LEN = 8

'-----------------------------------------------------------------------
' Return Codes
'-----------------------------------------------------------------------

Global Const EXMPJ_OK = 0

Global Const EXMPJ_INVALID_ITEM_NAME = 10000
Global Const EXMPJ_INVALID_ITEM_TYPE = 10001
Global Const EXMPJ_RETURN_BUFFER_TOO_SMALL = 10002
Global Const EXMPJ_INVALID_ADDRESS = 10003
Global Const EXMPJ_INVALID_CTNR_TYPE = 10004
Global Const EXMPJ_SHMEM_ERROR = 10005
Global Const EXMPJ_SEM_ERROR = 10006
Global Const EXMPJ_SEM_PERFORM_ERROR = 10007
Global Const EXMPJ_INVALID_CNT_TYPE = 10008
Global Const EXMPJ_RETRIEVE_INSTANCE = 10009
Global Const EXMPJ_INVALID_REQUEST = 10010
Global Const EXMPJ_PROGRAM_NOT_FOUND = 10011
Global Const EXMPJ_QUERY_TYPE_INFO = 10012
Global Const EXMPJ_START_PROCESS = 10013
Global Const EXMPJ_SUSPEND_PROCESS = 10014
Global Const EXMPJ_RESUME_PROCESS = 10015
Global Const EXMPJ_TERMINATE_PROCESS = 10016
Global Const EXMPJ_RESTART_PROCESS = 10017
Global Const EXMPJ_INTERNAL_ERROR = 10018
Global Const EXMPJ_PROCESS_NOT_FOUND = 10019
Global Const EXMPJ_ITEM_NOT_SET = 10020
Global Const EXMPJ_PROCESS_NOT_CLONEABLE = 10021
Global Const EXMPJ_PROCESS_NAME_TOO_LONG = 10022
Global Const EXMPJ_PROCESS_NOT_SUSPENDABLE = 10023
Global Const EXMPJ_PROCESS_NOT_RESUMEABLE = 10024
Global Const EXMPJ_PROCESS_NOT_TERMABLE = 10025
Global Const EXMPJ_PROCESS_NOT_RESTARTABLE = 10026
Global Const EXMPJ_PROCESS_NAME_INVALID = 10027
Global Const EXMPJ_ITEM_SIZE_MISMATCH = 10028
Global Const EXMPJ_CONNECTION = 10029
Global Const EXMPJ_MEM_ERROR = 10030
Global Const EXMPJ_ADDRESS_SIZE_MISMATCH = 10031
Global Const EXMPJ_WRONG_USER = 10032
Global Const EXMPJ_WRONG_PASSWORD = 10033
Global Const EXMPJ_INVALID_MODE = 10034
Global Const EXMPJ_WRONG_USER_ID_LEN = 10035
Global Const EXMPJ_WRONG_DATABASE_LEN = 10036
Global Const EXMPJ_WRONG_PASSWORD_LEN = 10037
Global Const EXMPJ_QUERY_NAME_FAILED = 10038
Global Const EXMPJ_NO_SET_FOR_CONTEXT_TOOL = 10039
Global Const EXMPJ_NOT_AUTHORIZED = 10040
Global Const EXMPJ_WRONG_SERVER_LEN = 10041
Global Const EXMPJ_LOGON_TWICE = 10042
Global Const EXMPJ_INVALID_USERID = 10043
Global Const EXMPJ_INVALID_DATABASE = 10044
Global Const EXMPJ_INVALID_PASSWORD = 10045
Global Const EXMPJ_INVALID_SERVER = 10046
Global Const EXMPJ_CHANGE_ACTIVITY_FAILED = 10047
Global Const EXMPJ_USER_NOT_ASSIGNED = 10048
Global Const EXMPJ_ACTIVITY_NOT_FOUND = 10049
Global Const EXMPJ_WRONG_ACTIVITY_STATE = 10050
Global Const EXMPJ_INVALID_VB_ARRAY = 10051
Global Const EXMPJ_VB_ERROR = 10052
Global Const EXMPJ_INVALID_ACTIVITY_NAME = 10053
Global Const EXMPJ_PROCESS_NOT_RUNNING = 10054
Global Const EXMPJ_NOT_PROGRAM_ACTIVITY = 10055
Global Const EXMPJ_PROCESS_NAME_NOT_UNIQUE = 10056
Global Const EXMPJ_CLONE_PROCESS = 10057
Global Const EXMPJ_PROCESS_NOT_STARTABLE = 10058
Global Const EXMPJ_DELETE_PROCESS = 10059
Global Const EXMPJ_PROCESS_NOT_DELETABLE = 10060
Global Const EXMPJ_ACCESS_MISMATCH = 10061
Global Const EXMPJ_WRONG_NODEID_LEN = 10062
Global Const EXMPJ_WRONG_PROTOCOL_LEN = 10063
Global Const EXMPJ_INVALID_NODEID = 10064
Global Const EXMPJ_INVALID_PROTOCOL = 10065
Global Const EXMPJ_USAGE_MISMATCH = 10066

'-----------------------------------------------------------------------
' API Functions
'-----------------------------------------------------------------------

'-----------------------------------------------------------------------
' Initialization API
'-----------------------------------------------------------------------

Declare Function ExmInit Lib "exmcjapv.dll" Alias "EXMVBINIT" () As Long

'-----------------------------------------------------------------------
' Session API
'-----------------------------------------------------------------------

Declare Function ExmGetSessionID Lib "exmcjapv.dll" Alias "EXMVBEXEID" (SessionID As String) As Long

'-----------------------------------------------------------------------
' Container API
'-----------------------------------------------------------------------

Type ExmApiAttrInfo
  Name As String             ' Fully qualified item name in dot notation
  Type As Long               ' Data type
  ArraySize As Long          ' Number of array elements
End Type

Declare Function ExmQueryDataStructureSize Lib "exmcjapv.dll" Alias "EXMVBQSTRSIZE" (ByVal SessionID As String, ByVal ContainerType As Long, Size As Long) As Long
Declare Function ExmQueryDataStructureSize2 Lib "exmcjapv.dll" Alias "EXMVBQSTRSIZE2" (ByVal SessionID As String, ByVal ContainerType As Long, Size As Long) As Long
Declare Function ExmQueryDataStructure Lib "exmcjapv.dll" Alias "EXMVBQSTR" (ByVal SessionID As String, ByVal ContainerType As Long, DataArea() As ExmApiAttrInfo, ActualSize As Long) As Long
Declare Function ExmQueryDataStructure2 Lib "exmcjapv.dll" Alias "EXMVBQSTR2" (ByVal SessionID As String, ByVal ContainerType As Long, DataArea() As ExmApiAttrInfo, ActualSize As Long) As Long
Declare Function ExmGetContainerItem Lib "exmcjapv.dll" Alias "EXMVBGTCI" (ByVal SessionID As String, ByVal ItemName As String, ByVal DataType As Long, DataArea As Variant) As Long
Declare Function ExmGetContainerItem2 Lib "exmcjapv.dll" Alias "EXMVBGTCI2" (ByVal SessionID As String, ByVal ItemName As String, ByVal DataType As Long, DataArea As Variant) As Long
Declare Function ExmSetContainerItem Lib "exmcjapv.dll" Alias "EXMVBSTCI" (ByVal SessionID As String, ByVal ItemName As String, ByVal DataArea As Variant) As Long
Declare Function ExmSetContainerItem2 Lib "exmcjapv.dll" Alias "EXMVBSTCI2" (ByVal SessionID As String, ByVal ItemName As String, ByVal DataArea As Variant) As Long
Declare Function ExmEnd2 Lib "exmcjapv.dll" Alias "EXMVBEND2" (ByVal SessionID As String) As Long

'-----------------------------------------------------------------------
' Process API
'-----------------------------------------------------------------------

Type ExmApiBegin
  UserID As String
  Password As String
  Database As String
  Server As String
End Type

Type ExmApiBegin2
  UserID As String
  Password As String
  Database As String
  Server As String
  NodeID As String
  Protocol As String
End Type

Type ExmApiMemberData
  Name As String             ' Fully qualified item name in dot notation
  DataArea As Variant        ' Value to be set
End Type

Declare Function ExmGetUserID Lib "exmcjapv.dll" Alias "EXMVBGETUSERID" (ByVal SessionID As String, ByVal IdLen As Long, UserID As String) As Long

Declare Function ExmLogon Lib "exmcjapv.dll" Alias "EXMVBBEGIN" (SessionData As ExmApiBegin, Handle As Long) As Long
Declare Function ExmLogon2 Lib "exmcjapv.dll" Alias "EXMVBBEGIN2" (SessionData As ExmApiBegin2, Handle As Long) As Long
Declare Function ExmPassThrough Lib "exmcjapv.dll" Alias "EXMVBBEGINSESS" (ByVal SessionID As String, Handle As Long) As Long
Declare Function ExmLogoff Lib "exmcjapv.dll" Alias "EXMVBEND" (ByVal Handle As Long) As Long

Declare Function ExmCloneProcess Lib "exmcjapv.dll" Alias "EXMVBCLPRC" (ByVal Handle As Long, ByVal TemplateName As String, InstanceName As String) As Long
Declare Function ExmStartProcess Lib "exmcjapv.dll" Alias "EXMVBSTPRC" (ByVal Handle As Long, ByVal TemplateName As String, InstanceName As String, ByVal Size As Long, MemberData() As ExmApiMemberData) As Long
Declare Function ExmStartProcess2 Lib "exmcjapv.dll" Alias "EXMVBSTPRC2" (ByVal Handle As Long, ByVal TemplateName As String, InstanceName As String, ByVal Size As Long, MemberData() As ExmApiMemberData) As Long
Declare Function ExmStartUniqueProcess Lib "exmcjapv.dll" Alias "EXMVBSTUNPRC" (ByVal Handle As Long, ByVal TemplateName As String, InstanceName As String, ByVal Size As Long, MemberData() As ExmApiMemberData) As Long
Declare Function ExmStartUniqueProcess2 Lib "exmcjapv.dll" Alias "EXMVBSTUNPRC2" (ByVal Handle As Long, ByVal TemplateName As String, InstanceName As String, ByVal Size As Long, MemberData() As ExmApiMemberData) As Long
Declare Function ExmTerminateProcess Lib "exmcjapv.dll" Alias "EXMVBTERP" (ByVal Handle As Long, ByVal InstanceName As String, TopLevelProcess As String, ByVal Mode As Long) As Long
Declare Function ExmRestartProcess Lib "exmcjapv.dll" Alias "EXMVBRSTP" (ByVal Handle As Long, ByVal InstanceName As String, TopLevelProcess As String, ByVal Mode As Long) As Long
Declare Function ExmDeleteProcess Lib "exmcjapv.dll" Alias "EXMVBDELP" (ByVal Handle As Long, ByVal InstanceName As String, TopLevelProcess As String, ByVal Mode As Long) As Long
Declare Function ExmSuspendProcess Lib "exmcjapv.dll" Alias "EXMVBSUSP" (ByVal Handle As Long, ByVal InstanceName As String, TopLevelProcess As String, ByVal Mode As Long) As Long
Declare Function ExmResumeProcess Lib "exmcjapv.dll" Alias "EXMVBRESP" (ByVal Handle As Long, ByVal InstanceName As String, TopLevelProcess As String, ByVal Mode As Long) As Long
Declare Function ExmChangeActivityState Lib "exmcjapv.dll" Alias "EXMVBACTSTATE" (ByVal Handle As Long, ByVal InstanceName As String, ByVal QualActName As String, ByVal Mode As Long, ActState As Long) As Long

