    ' Data declarations
    Dim Param()
    Dim ArgVar
    Dim ulRC
    Dim SessionID As String
    Dim InContain() As ExmApiAttrInfo
    Dim OutContain() As ExmApiAttrInfo
    Dim InNumItems As Long
    Dim OutNumItems As Long

Function ConstructApiParms ()

   ' Declarations
   Dim AttrName(), AttrValue(), AttrList()
   Dim CCList(), ItemList(), IxClassList()
   Dim IndexClass(), WBList()

   '   Verify VHLPI Function name specified
   If Param(0) = 0 Then
      ConstructApiParms = 902
      Exit Function
   End If

   '----------------------------------------------------------------------
   '   Validate VHLPI Function name specified in Param 1
   '----------------------------------------------------------------------
   Select Case Param(1)
      Case "VbVhlAddFolderItem"
          '   Verify enough Parameters were specified
          If Param(0) < 3 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          FolderId = Param(3)
          ulRC = VbVhlAddFolderItem(ItemId, FolderId)
      Case "VbVhlAdminItemNoteLog"
          '   Verify enough Parameters were specified
          If Param(0) < 4 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          FuncInd = Param(3)
          NoteText = Param(4)
          ulRC = VbVhlAdminItemNoteLog(ItemId, FuncInd, NoteText)
          ' Check if getting note into FM container variable
          If (FuncInd = "GET") And (Left(Param(4), 4) = "OUT.") Then
             ulRC = ExmSetContainerItem2(SessionID, Mid(Param(4), 5), NoteText)
          End If
      Case "VbVhlChangeItemIndex"
          '   Verify enough Parameters were specified
          If Param(0) < 5 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          ClassName = Param(3)
          Namcnt = Param(4)
          ReDim AttrName(Namcnt + 1)
          AttrName(0) = Namcnt
          For I = 1 To Namcnt
             AttrName(I) = Param(4 + I)
          Next I
          Valcnt = Param(5 + Namcnt)
          ReDim AttrValue(Valcnt + 1)
          AttrValue(0) = Valcnt
          For I = 1 To Valcnt
             AttrValue(I) = Param(5 + Namcnt + I)
          Next I
          ulRC = VbVhlChangeItemIndex(ItemId, ClassName, AttrName(), AttrValue())
      Case "VbVhlCheckInItem"
          '   Verify enough Parameters were specified
          If Param(0) < 3 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          ulRC = VbVhlCheckInItem(ItemId, UserId)
          ' Check if UserId is a FM container variable
          If (Left(Param(3), 4) = "OUT.") Then
             ulRC = ExmSetContainerItem2(SessionID, Mid(Param(3), 5), UserId)
          End If
      Case "VbVhlCheckOutItem"
          '   Verify enough Parameters were specified
          If Param(0) < 3 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          ulRC = VbVhlCheckOutItem(ItemId, UserId)
          ' Check if UserId is a FM container variable
          If (Left(Param(3), 4) = "OUT.") Then
             ulRC = ExmSetContainerItem2(SessionID, Mid(Param(3), 5), UserId)
          End If
      Case "VbVhlCloseDocViews"
          '   Verify enough Parameters were specified
          If Param(0) < 2 Then
             ConstructApiParms = 902
             Exit Function
          End If
          fUpdate = Param(2)
          ulRC = VbVhlCloseDocViews(fUpdate)
      Case "VbVhlCopyDoc"
          '   Verify enough Parameters were specified
          If Param(0) < 6 Then
             ConstructApiParms = 902
             Exit Function
          End If
          DocId = Param(3)
          ClassName = Param(4)
          Namcnt = Param(5)
          ReDim AttrName(Namcnt + 1)
          AttrName(0) = Namcnt
          For I = 1 To Namcnt
             AttrName(I) = Param(5 + I)
          Next I
          Valcnt = Param(6 + Namcnt)
          ReDim AttrValue(Valcnt + 1)
          AttrValue(0) = Valcnt
          For I = 1 To Valcnt
             AttrValue(I) = Param(6 + Namcnt + I)
          Next I
          ulRC = VbVhlCopyDoc(NewDocId, DocId, ClassName, AttrName(), AttrValue())
          ' Check if NewDocId is a FM container variable
          If (Left(Param(2), 4) = "OUT.") Then
             ulRC = ExmSetContainerItem2(SessionID, Mid(Param(2), 5), NewDocId)
          End If
      Case "VbVhlCreateFolder"
          '   Verify enough Parameters were specified
          If Param(0) < 5 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ClassName = Param(3)
          Namcnt = Param(4)
          ReDim AttrName(Namcnt + 1)
          AttrName(0) = Namcnt
          For I = 1 To Namcnt
             AttrName(I) = Param(4 + I)
          Next I
          Valcnt = Param(5 + Namcnt)
          ReDim AttrValue(Valcnt + 1)
          AttrValue(0) = Valcnt
          For I = 1 To Valcnt
             AttrValue(I) = Param(5 + Namcnt + I)
          Next I
          ulRC = VbVhlCreateFolder(FolderId, ClassName, AttrName(), AttrValue())
          ' Check if FolderId is a FM container variable
          If (Left(Param(2), 4) = "OUT.") Then
             ulRC = ExmSetContainerItem2(SessionID, Mid(Param(2), 5), FolderId)
          End If
      Case "VbVhlCreateFolderAddItem"
          '   Verify enough Parameters were specified
          If Param(0) < 6 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(3)
          ClassName = Param(4)
          Namcnt = Param(5)
          ReDim AttrName(Namcnt + 1)
          AttrName(0) = Namcnt
          For I = 1 To Namcnt
             AttrName(I) = Param(5 + I)
          Next I
          Valcnt = Param(6 + Namcnt)
          ReDim AttrValue(Valcnt + 1)
          AttrValue(0) = Valcnt
          For I = 1 To Valcnt
             AttrValue(I) = Param(6 + Namcnt + I)
          Next I
          ulRC = VbVhlCreateFolderAddItem(FolderId, ItemId, ClassName, AttrName(), AttrValue())
          ' Check if FolderId is a FM container variable
          If (Left(Param(2), 4) = "OUT.") Then
             ulRC = ExmSetContainerItem2(SessionID, Mid(Param(2), 5), FolderId)
          End If
      Case "VbVhlDeleteItem"
          '   Verify enough Parameters were specified
          If Param(0) < 2 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          ulRC = VbVhlDeleteItem(ItemId)
      Case "VbVhlDisplayDocView"
          '   Verify enough Parameters were specified
          If Param(0) < 3 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          fUpdate = Param(3)
          ulRC = VbVhlDisplayDocView(ItemId, fUpdate)
      Case "VbVhlDisplayVIItem"
          '   Verify enough Parameters were specified
          If Param(0) < 3 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          fUpdate = Param(3)
          ulRC = VbVhlDisplayVIItem(ItemId, fUpdate)
      Case "VbVhlExportDocObj"
          '   Verify enough Parameters were specified
          If Param(0) < 4 Then
             ConstructApiParms = 902
             Exit Function
          End If
          DocId = Param(2)
          Filename = Param(3)
          PartNum = Param(4)
          ulRC = VbVhlExportDocObj(DocId, Filename, PartNum)
'      Case "VbVhlGetVIUserID"
'          ulRC = VbVhlGetVIUserID ()
      Case "VbVhlImportDocObj"
          '   Verify enough Parameters were specified
          If Param(0) < 7 Then
             ConstructApiParms = 902
             Exit Function
          End If
          Filename = Param(3)
          ContentClass = Param(4)
          ClassName = Param(5)
          Namcnt = Param(6)
          ReDim AttrName(Namcnt + 1)
          AttrName(0) = Namcnt
          For I = 1 To Namcnt
             AttrName(I) = Param(6 + I)
          Next I
          Valcnt = Param(7 + Namcnt)
          ReDim AttrValue(Valcnt + 1)
          AttrValue(0) = Valcnt
          For I = 1 To Valcnt
             AttrValue(I) = Param(7 + Namcnt + I)
          Next I
          ulRC = VbVhlImportDocObj(DocId, Filename, ContentClass, ClassName, AttrName(), AttrValue())
          ' Check if DocId is a FM container variable
          If (Left(Param(2), 4) = "OUT.") Then
             ulRC = ExmSetContainerItem2(SessionID, Mid(Param(2), 5), DocId)
          End If
      Case "VbVhlListContClasses"
          ulRC = VbVhlListContClasses(CCList())
      Case "VbVhlListFolderItems"
          ulRC = VbVhlListFolderItems(ItemList(), FolderId, IndexClass())
      Case "VbVhlListFolderItemsAttr"
          ulRC = VbVhlListFolderItemsAttr(ItemList(), FolderId)
'      Case "VbVhlListFolderXrefItem"
'          ulRC = 0
      Case "VbVhlListIndexClassAttr"
          ulRC = VbVhlListIndexClassAttr(AttrList(), ClassName)
      Case "VbVhlListIndexClasses"
          ulRC = VbVhlListIndexClasses(IxClassList())
      Case "VbVhlListItemCC"
          ulRC = VbVhlListItemCC(ItemCC, ItemId, PartNum)
      Case "VbVhlListItemInfo"
          ulRC = VbVhlListItemInfo(ItemList(), ItemId)
      Case "VbVhlListWBItems"
          ulRC = VbVhlListWBItems(ItemList(), WBItemId)
      Case "VbVhlListWorkBaskets"
          ulRC = VbVhlListWorkBaskets(WBList())
      Case "VbVhlRemoveFolderItem"
          '   Verify enough Parameters were specified
          If Param(0) < 3 Then
             ConstructApiParms = 902
             Exit Function
          End If
          ItemId = Param(2)
          FolderId = Param(3)
          ulRC = VbVhlRemoveFolderItem(ItemId, FolderId)
      Case "VbVhlScanDoc"
          ulRC = VbVhlScanDoc()
      Case "VbVhlSearchAdv"
          ulRC = VbVhlSearchAdv(ItemList(), ClassName, Criteria, TypeFilter, WIPFilter, SuspendFilter)
      Case "VbVhlSearchItem"
          ulRC = VbVhlSearchItem(ItemList(), ClassName, Criteria)
      Case Else
          ulRC = 910
   End Select

   ConstructApiParams = ulRC

End Function

Function ExtractArgs ()

   '----------------------------------------------------------------------
   '   Parse and validate arguments from varstring place holder
   '----------------------------------------------------------------------
   J = 0
   ReDim Param(1)
   Param(0) = J
   Do While ArgVar <> ""
      J = J + 1
      ReDim Preserve Param(J + 1)

      '-------------------------------------------------------------------
      '   Test for single or double quotes and extract parm inside quotes
      '-------------------------------------------------------------------
      ulRC = Test4Quote(J)
      If ulRC > 1 Then
         ExtractArgs = 1
         Exit Function
      ElseIf ulRC = 0 Then
         '----------------------------------------------------------------
         '   No single or double quotes, argument = next word
         '   Remove comma or blank separator
         '----------------------------------------------------------------
         EndBlkPos = InStr(1, ArgVar, " ")
         EndComPos = InStr(1, ArgVar, ",")
         If (EndBlkPos = 0) Then
            EndPos = EndComPos
         ElseIf (EndComPos = 0) Then
            EndPos = EndBlkPos
         ElseIf (EndBlkPos < EndComPos) Then
            EndPos = EndBlkPos
         Else
            EndPos = EndComPos
         End If
         If EndPos = 0 Then
            Param(J) = ArgVar
            ArgVar = ""
         Else
            Param(J) = Left(ArgVar, EndPos - 1)
            ArgVar = Mid(ArgVar, EndPos + 1)
         End If
         ArgVar = Trim(ArgVar)
      End If
   Loop

   Param(0) = J

End Function

Sub FmCheckContainer (OUT_ContainerVar, OUT_ContainerType, Indx)

   ' Declarations
   Dim OUT_ContainerValue As Variant

   '----------------------------------------------------------------------
   '   Find input data container value and set to output container value
   '----------------------------------------------------------------------
   found = False
   For I = 0 To InNumItems - 1
      If InContain(I).Name = OUT_ContainerVar Then
         found = True
         '   Check for array variables
         If Indx = 0 Then
            ulRC = ExmGetContainerItem2(SessionID, InContain(I).Name, InContain(I).Type, OUT_ContainerValue)
         Else
            ulRC = ExmGetContainerItem2(SessionID, InContain(I).Name & "[" & (Indx - 1) & "]", InContain(I).Type, OUT_ContainerValue)
         End If
         Exit For
      End If
   Next I

   '----------------------------------------------------------------------
   '   If input data container is uninitialized - initialize output
   '----------------------------------------------------------------------
   If found = False Then
        Select Case OUT_ContainerType
           Case 0
                OUT_ContainerValue = 0
           Case 1
                OUT_ContainerValue = ""
           Case 2
                OUT_ContainerValue = 0#
           Case Else
                OUT_ContainerValue = ""
        End Select
   End If

   '----------------------------------------------------------------------
   '   Set output container variable
   '----------------------------------------------------------------------
   If Indx = 0 Then
      ulRC = ExmSetContainerItem2(SessionID, OUT_ContainerVar, OUT_ContainerValue)
   Else
      ulRC = ExmSetContainerItem2(SessionID, OUT_ContainerVar & "[" & (Indx - 1) & "]", OUT_ContainerValue)
   End If

End Sub

Sub FmCopyContainer ()
   '----------------------------------------------------------------------
   '   Copies all (IN...) to (OUT...) variables
   '----------------------------------------------------------------------

   '----------------------------------------------------------------------
   '   Loop through all the members in the output data container
   '----------------------------------------------------------------------
   For I = 0 To OutNumItems - 1
      '-------------------------------------------------------------------
      '   Exclude all predefined data structure members
      '-------------------------------------------------------------------
      If (OutContain(I).Name <> "_PROCESS") And (OutContain(I).Name <> "_ACTIVITY") Then
         '----------------------------------------------------------------
         '   Test for array
         '----------------------------------------------------------------
         If OutContain(I).ArraySize > 0 Then
            '-----------------------------------------------------------
            '   Loop through all the array elements
            '-----------------------------------------------------------
            For J = 1 To OutContain(I).ArraySize
               '--------------------------------------------------------
               '   Reset meta data output container variable to its value
               '--------------------------------------------------------
               Call FmCheckContainer(OutContain(I).Name, OutContain(I).Type, J)
            Next J
         Else
            '-------------------------------------------------------------
            '   Reset meta data output container variable to its value
            '-------------------------------------------------------------
            J = 0
            Call FmCheckContainer(OutContain(I).Name, OutContain(I).Type, J)
         End If
      End If
   Next I

End Sub

Function FmGetContainers ()

   ' Declarations
   Dim Size As Long

   ' Get Input Data Container size
   ulRC = ExmQueryDataStructureSize2(SessionID, EXMPJ_INPUT_CTNR, InNumItems)
   If ulRC <> 0 Then
      FmGetContainer = ulRC
      Exit Function
   End If

   ' Get Input Data Container structure
   ReDim InContain(InNumItems)
   ulRC = ExmQueryDataStructure2(SessionID, EXMPJ_INPUT_CTNR, InContain(), Size)
   If ulRC <> 0 Then
      FmGetContainer = ulRC
      Exit Function
   End If

   ' Get Output Data Container size
   ulRC = ExmQueryDataStructureSize2(SessionID, EXMPJ_OUTPUT_CTNR, OutNumItems)
   If ulRC <> 0 Then
      FmGetContainer = ulRC
      Exit Function
   End If

   ' Get Output Data Container structure
   ReDim OutContain(OutNumItems)
   ulRC = ExmQueryDataStructure2(SessionID, EXMPJ_OUTPUT_CTNR, OutContain(), Size)
   If ulRC <> 0 Then
      FmGetContainer = ulRC
      Exit Function
   End If

   FmGetContainer = ulRC

End Function

Sub Main ()

   '-------------------------------------------------------------------------
   '   FlowMark/2 initialization routines:
   '   -  Initialize data container Api access
   '   -  Get the session Id
   '-------------------------------------------------------------------------
   ulRC = ExmInit()
   If ulRC <> 0 Then
      GoTo ExitMain
   End If

   ulRC = ExmGetSessionID(SessionID)
   If ulRC <> 0 Then
      GoTo ExitMain
   End If

   '-------------------------------------------------------------------------
   '   Get access to VisualInfo
   '-------------------------------------------------------------------------
   ulRC = VbVhlLoadFuncs()

   '-------------------------------------------------------------------------
   '   FlowMark/2 prep routines:
   '   -  Get input data container
   '   -  Copy input to output data container
   '-------------------------------------------------------------------------
   If FmGetContainers() = 0 Then
      Call FmCopyContainer
      ulRC = ExmEnd2(SessionID)
   Else
      GoTo ExitMain
   End If

   '-------------------------------------------------------------------------
   '   Save arguments passed and parse/validate each Param
   '-------------------------------------------------------------------------
   ArgVar = Command

   If ExtractArgs() <> 0 Then
      '   Error in arguments passed
      GoTo CloseFM
   End If

   '-------------------------------------------------------------------------
   '   Construct API Params and call the API
   '-------------------------------------------------------------------------
   ulRC = ConstructApiParms()

CloseFM:
   '-------------------------------------------------------------------------
   '   End access to VisualInfo
   '-------------------------------------------------------------------------
   ulRC = VbVhlDropFuncs()

   '-------------------------------------------------------------------------
   '   Set FlowMark output data container
   '-------------------------------------------------------------------------
   ulRC = ExmSetContainerItem2(SessionID, "_RC", ulRC)
   ulRC = ExmEnd2(SessionID)

ExitMain:
   End

End Sub

Function Test4Quote (J)

    Static Quote(2) As String

   '----------------------------------------------------------------------
   '   Test for single/double quotes & extract Param inside the quotes
   '----------------------------------------------------------------------
   Quote(1) = "'"
   Quote(2) = Chr(34)

   For I = 1 To 2
      If Left$(ArgVar, 1) <> Quote(I) Then
         ulRC = 0
      Else
         Quote2Pos = InStr(2, ArgVar, Quote(I))
         I = 2
         If Quote2Pos = 0 Then
            ulRC = 2
         Else
            ulRC = 1
            Param(J) = Mid$(ArgVar, 2, Quote2Pos - 2)
            ArgVar = Mid$(ArgVar, Quote2Pos + 1)
            '-------------------------------------------------------
            '   Test for comma separator and remove
            '-------------------------------------------------------
            If Left$(ArgVar, 1) = "," Then
               ArgVar = Trim$(Mid$(ArgVar, 2))
            Else
               ArgVar = Trim$(ArgVar)
            End If
         End If
      End If
   Next I

   Test4Quote = ulRC

End Function

