'/****************************************************************************/
'/*                                                                          */
'/* MODULE: FRNWWFVB.BAS                                                     */
'/*                                                                          */
'/* 5697-250                                                                 */
'/* (C) Copyright IBM Corporation 1996.  All Rights Reserved.                */
'/*                                                                          */
'/* DERIVATIVE RIGHTS:                                                       */
'/* ------------------                                                       */
'/* This program is provided for the customer's use and the customer is      */
'/* granted permission to copy this program to the extent reasonably         */
'/* required for such use.  All title, ownership, and rights to this         */
'/* program and any copies remain with IBM, irrespective of the ownership    */
'/* of the media on which the program resides.  The customer is permitted    */
'/* to create derivative works to this program.  However, all copies of      */
'/* the program and its derivative works must contain the IBM copyright      */
'/* notice.  The customer understands and agrees that this program in and    */
'/* of itself is not to be sold or distributed.  The customer is free to     */
'/* sell, distribute, and commercially exploit any derivative works          */
'/* created from this program.                                               */
'/*                                                                          */
'/* DISCLAIMER OF WARRANTIES:                                                */
'/* -------------------------                                                */
'/* The following "enclosed" code is sample code created by IBM              */
'/* Corporation.  This sample code is not part of any standard IBM product   */
'/* and is provided to you solely for the purpose of assisting you in the    */
'/* development of your applications.  The code is provided "AS IS",         */
'/* without warranty of any kind.  IBM shall not be liable for any damages   */
'/* arising out of your use of the sample code, even if they have been       */
'/* advised of the possibility of such damages.                              */
'/*                                                                          */
'/* DESCRIPTION:                                                             */
'/* ------------                                                             */
'/* This program provides a VisualInfo High Level Programming Interface      */
'/* for Visual Basic applications. The enclosed VHLPI functions use the      */
'/* OLE Automation interface of the VisualInfo Client application which      */
'/* must be running (or invokeable) for these functions to work.             */
'/*                                                                          */
'/****************************************************************************/
    ' Data declarations
    Global VhlApplObj As Object
    Global VhlDocsObj As Object
    Global VhlErrorObj As Object

Function VbVhlAddFolderItem (ItemID, FolderId)

    ' Declarations
    Dim ItemObj As Object
    Dim FolderObj As Object

    ' Setup Error handler
    On Error GoTo VhlAddFolderError
    ulRC = 0

    ' Get the Folder Object
    Set FolderObj = VhlApplObj.ItemID(FolderId)

    ' Get the ItemID Object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Put ItemId into Folder
    ulRC = ItemObj.AddToFolder(FolderObj)

VhlAddFolderEnd:

    ' Free the objects
    Set ItemObj = Nothing
    Set FolderObj = Nothing

    ' Set return value to error code
    VbVhlAddFolderItem = ulRC

    Exit Function

VhlAddFolderError:

    ' Set return value to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlAddFolderEnd

End Function

Function VbVhlAdminItemNoteLog (ItemID, FuncInd, NoteText)

    ' Declarations
    Dim ItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlAdminNoteError
    ulRC = 0

    ' Get the Item object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Determine what to do
    Select Case FuncInd
    Case "APPEND"
       OldNoteText = ItemObj.GetNotes
       ulRC = ItemObj.ChangeNotes(OldNoteText & NoteText)
    Case "DELETE"
       OldNoteText = ItemObj.GetNotes
       ulRC = ItemObj.ChangeNotes(" ")
    Case "REPLACE"
       OldNoteText = ItemObj.GetNotes
       ulRC = ItemObj.ChangeNotes(NoteText)
    Case "GET"
       NoteText = ItemObj.GetNotes
    End Select

    ' Unlock the Note log
    If (ulRC = 0) Then
       ulRC = ItemObj.CloseNotes
    End If

VhlAdminNoteEnd:

    ' Free the object
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlAdminItemNoteLog = ulRC

    Exit Function

VhlAdminNoteError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlAdminNoteEnd

End Function

Function VbVhlChangeItemIndex (ItemID, ClassName, AttrName(), AttrValue())

    ' Declarations
    Dim ItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlChgIndexError
    ulRC = 0

    ' Get the Item
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Update Item index class
    ItemObj.Class = ClassName

    ' Update the Item attributes
    For i = 1 To AttrName(0)
       ItemObj.KeyFields(AttrName(i)) = AttrValue(i)
    Next
    ' Update the Items Index Class and attribute information
    ulRC = ItemObj.UpdateIndex

VhlChgIndexEnd:

    ' Free the objects
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlChangeItemIndex = ulRC

    Exit Function

VhlChgIndexError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlChgIndexEnd

End Function

Function VbVhlCheckInItem (ItemID, UserId)

    ' Declarations
    Dim ItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlCheckInError
    ulRC = 0

    ' Get the Item object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' CheckIn the Item
    ulRC = ItemObj.CheckIn

    ' Store the Checked out status
    UserId = ItemObj.CheckedStatus

VhlCheckInEnd:

    ' Free the object
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlCheckInItem = ulRC

    Exit Function

VhlCheckInError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlCheckInEnd

End Function

Function VbVhlCheckOutItem (ItemID, UserId)

    ' Declarations
    Dim ItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlCheckOutError
    ulRC = 0

    ' Get the Item object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' CheckOut the Item
    ulRC = ItemObj.CheckOut

    ' Store the Checked out status
    UserId = ItemObj.CheckedStatus

VhlCheckOutEnd:

    ' Free the object
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlCheckOutItem = ulRC

    Exit Function

VhlCheckOutError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlCheckOutEnd

End Function

Function VbVhlCloseDocViews (fUpdate)

    ' Declarations
    Dim ImageObj As Object

    ' Setup Error handler
    On Error GoTo VhlCloseDocError
    ulRC = 0

    ' Close Document being displayed
    Set ImageObj = VhlApplObj.Image
    If Not (ImageObj Is Nothing) Then
       ImageObj.CloseIt (fUpdate)
    End If

VhlCloseDocEnd:

    ' Set return value to error code
    VbVhlCloseDocViews = ulRC

    Exit Function

VhlCloseDocError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlCloseDocEnd

End Function

Function VbVhlCopyDoc (NewDocId, DocId, ClassName, AttrName(), AttrValue())

    ' Declarations
    Dim ItemObj As Object
    Dim NewItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlCopyDocError
    ulRC = 0

    ' Get the Document object
    Set ItemObj = VhlApplObj.ItemID(DocId)
    ' Make sure the object is a document
    If ItemObj.Type <> 1 Then
       ' Return with error - SBVI_BAD_DOCUMENT
       ulRC = 909
       GoTo VhlCopyDocEnd
    End If

    ' Create a new document
    Set NewItemObj = VhlApplObj.CreateDocument("COPY")
    NewDocId = NewItemObj.ItemID

    ' Update the new document with Index Class information if provided
    If (ulRC = 0) And (ClassName <> "") Then
       ' Change the Items Index Class
       ulRC = VbVhlChangeItemIndex(NewDocId, ClassName, AttrName(), AttrValue())
    End If

    ' Copy document base parts into new document
    i = 0
    While (ulRC = 0) And (i < ItemObj.PartCount)
       ContentClass = ItemObj.GetPartContentClass(i)
       TempFile = ItemObj.GetPartFile(i)
       ulRC = NewItemObj.AddPart(TempFile, ContentClass)
       i = i + 1
    Wend
    ' Close the original document
    RC = ItemObj.CloseParts

VhlCopyDocEnd:

    ' Free the objects
    Set ItemObj = Nothing
    Set NewItemObj = Nothing

    ' Set return value to error code
    VbVhlCopyDoc = ulRC

    Exit Function

VhlCopyDocError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlCopyDocEnd

End Function

Function VbVhlCreateFolder (FolderId, ClassName, AttrName(), AttrValue())

    ' Declarations
    Dim FolderObj As Object

    ' Setup Error handler
    On Error GoTo VhlCreFoldError
    ulRC = 0

    ' Create the folder
    Set FolderObj = VhlApplObj.CreateFolder("CREATE")
    FolderId = FolderObj.ItemID
    If (ulRC = 0) And (ClassName <> "") Then
       ' Change the Items Index Class
       ulRC = VbVhlChangeItemIndex(FolderId, ClassName, AttrName(), AttrValue())
    End If

VhlCreFoldEnd:

    ' Free the object
    Set FolderObj = Nothing

    ' Set return value to error code
    VbVhlCreateFolder = ulRC

    Exit Function

VhlCreFoldError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlCreFoldEnd

End Function

Function VbVhlCreateFolderAddItem (FolderId, ItemID, ClassName, AttrName(), AttrValue())

    ' Declarations
    Dim FolderObj As Object
    Dim ItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlCreFoldAddError
    ulRC = 0

    ' Create the folder
    Set FolderObj = VhlApplObj.CreateFolder("CREATE")
    FolderId = FolderObj.ItemID

    ' Get the ItemID Object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Put ItemId into Folder
    ulRC = ItemObj.AddToFolder(FolderObj)

    If (ulRC = 0) And (ClassName <> "") Then
       ' Change the Items Index Class
       ulRC = VbVhlChangeItemIndex(FolderId, ClassName, AttrName(), AttrValue())
    End If

VhlCreFoldAddEnd:

    ' Free the objects
    Set FolderObj = Nothing
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlCreateFolderAddItem = ulRC

    Exit Function

VhlCreFoldAddError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlCreFoldAddEnd

End Function

Function VbVhlDeleteItem (ItemID)

    ' Declarations
    Dim ItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlDeleteError
    ulRC = 0

    ' Get the ItemID Object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Delete the Item
    ulRC = ItemObj.DeleteIt

VhlDeleteEnd:

    ' Free the objects
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlDeleteItem = ulRC

    Exit Function

VhlDeleteError:

    ' Set return value to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlDeleteEnd

End Function

Function VbVhlDisplayDocView (ItemID, fUpdate)

    ' Declarations
    Dim ItemObj As Object
    Dim ImageObj As Object

    ' Setup Error handler
    On Error GoTo VhlDispDocError
    ulRC = 0

    ' Get the Item object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Close Document being displayed
    Set ImageObj = VhlApplObj.Image
    If Not (ImageObj Is Nothing) Then
       ImageObj.CloseIt (fUpdate)
    End If

    ' Display Document
    ulRC = ImageObj.OpenDocument(ItemObj)

VhlDispDocEnd:

    ' Free the object
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlDisplayDocView = ulRC

    Exit Function

VhlDispDocError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlDispDocEnd

End Function

Function VbVhlDisplayVIItem (ItemID, fUpdate)

    ' Declarations
    Dim ItemObj As Object
    Dim ImageObj As Object
    Dim FolderObj As Object

    ' Setup Error handler
    On Error GoTo VhlDispItemError
    ulRC = 0

    ' Get the Item object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Find out if the item is a folder or a document
    If (ItemObj.Type = 1) Then
       ' Close Document being displayed
       Set ImageObj = VhlApplObj.Image
       If Not (ImageObj Is Nothing) Then
          ImageObj.CloseIt (fUpdate)
       End If
       ' Display Document
       ulRC = ImageObj.OpenDocument(ItemObj)
    Else
        ' Must be a folder. Display it.
        Set FolderObj = VhlDocsObj.OpenTOC(ItemObj)
    End If

VhlDispItemEnd:

    ' Free the object
    Set ItemObj = Nothing
    Set FolderObj = Nothing
    Set ImageObj = Nothing

    ' Set return value to error code
    VbVhlDisplayVIItem = ulRC

    Exit Function

VhlDispItemError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlDispItemEnd

End Function

Function VbVhlDropFuncs ()

    ' Setup Error handler
    On Error GoTo VhlDropError

    ' End access with OLE interface
    ulRC = 0
    Set VhlDocsObj = Nothing
    Set VhlErrorObj = Nothing
    Set VhlApplObj = Nothing

VhlDropEnd:

    ' Set return value to error code
    VbVhlDropFuncs = ulRC

    Exit Function

VhlDropError:

    ' Set return code to error code
    ulRC = Err
    Resume VhlDropEnd

End Function

Function VbVhlExportDocObj (DocId, Filename, PartNum)

    ' Declarations
    Dim DocObj As Object

    ' Setup Error handler
    On Error GoTo VhlExportDocError
    ulRC = 0

    ' Get the document object
    Set DocObj = VhlApplObj.ItemID(DocId)

    ' Copy document base part into file
    TempFile = DocObj.GetPartFile(PartNum)
    Name TempFile As Filename
    ' Close the document
    RC = DocObj.CloseParts

VhlExportDocEnd:

    ' Free the object
    Set DocObj = Nothing

    ' Set return value to error code
    VbVhlExportDocObj = ulRC

    Exit Function

VhlExportDocError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlExportDocEnd

End Function

Function VbVhlGetVIUserID ()

    ' Setup Error handler
    On Error GoTo VhlGetUserError
    ulRC = 0

    ' Set return value to UserId
    VbVhlGetVIUserID = VhlApplObj.User

VhlGetUserEnd:

    Exit Function

VhlGetUserError:

    ' Set return code to error code
    VbVhlGetVIUserID = VhlErrorObj.ReturnCode

    Resume VhlGetUserEnd

End Function

Function VbVhlImportDocObj (DocId, Filename, ContentClass, ClassName, AttrName(), AttrValue())

    ' Declarations
    Dim DocObj As Object

    ' Setup Error handler
    On Error GoTo VhlImportDocError
    ulRC = 0

    ' Create the document and add the file
    Set DocObj = VhlApplObj.CreateDocument("IMPORT")
    DocId = DocObj.ItemID
    ulRC = DocObj.AddPart(Filename, ContentClass)
    If (ulRC = 0) And (DocObj.CheckedStatus <> "") Then
       ' CheckIn the Item
       ulRC = DocObj.CheckIn
    End If

    If (ulRC = 0) And (ClassName <> "") Then
       ' Change the Items Index Class
       ulRC = VbVhlChangeItemIndex(DocId, ClassName, AttrName(), AttrValue())
    End If

VhlImportDocEnd:

    ' Free the object
    Set DocObj = Nothing

    ' Set return value to error code
    VbVhlImportDocObj = ulRC

    Exit Function

VhlImportDocError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlImportDocEnd

End Function

Function VbVhlListContClasses (CCList())

    ' Declarations
    Dim i, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlContListError
    ulRC = 0

    ' Get the list of Cont Classes
    strRet = VhlApplObj.ContentClassList(";")
    ulTotLen = Len(strRet)

    ' Add Cont classes to List array
    i = 0
    ReDim CCList(1)
    CCList(0) = 0
    ulStart = 1
    Do
       ' Each name separated by a ";"
       ulEnd = InStr(ulStart, strRet, ";")
       If (ulEnd = 0) Then
          ulEnd = ulTotLen + 1
       End If
       ulLen = ulEnd - ulStart

       ' Set next array variable to Cont Class name
       i = i + 1
       ReDim Preserve CCList(i + 1)
       CCList(i) = Mid$(strRet, ulStart, ulLen)

       ' Setup for next loop
       ulStart = ulEnd + 1
    Loop Until (ulStart >= ulTotLen)

    ' Set total number of Cont Classes in array
    CCList(0) = i

VhlContListEnd:

    ' Set return value to error code
    VbVhlListContClasses = ulRC

    Exit Function

VhlContListError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlContListEnd

End Function

Function VbVhlListFolderItems (ItemList(), FolderId, IndexClass())

    ' Declarations
    Dim FolderObj As Object
    Dim ContentObj As Object
    Dim ulTOCCnt, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlLstFldError
    ulRC = 0

    ' Get the Folder Object
    Set FolderObj = VhlApplObj.ItemID(FolderId)

    ' Setup return array based on size of folder
    ulTOCCnt = FolderObj.TOCCount
    ReDim ItemList(ulTOCCnt + 1, 4)
    ItemList(0, 0) = 0

    ' Get the list of Item Objects in the Folder
    j = 1
    For i = 1 To ulTOCCnt
       Set ContentObj = FolderObj.GetTOCItem(i - 1)
       ItemList(j, 0) = 3
       ItemList(j, 1) = ContentObj.ItemID
       ItemList(j, 2) = ContentObj.Type
       ItemList(j, 3) = ContentObj.Class
       Set ContentObj = Nothing
       ' Check if Index Class filter was provided
       Found = False
       If IndexClass(0) <> 0 Then
          For k = 1 To IndexClass(0)
             If IndexClass(k) = ItemList(j, 3) Then
                Found = True
                Exit For
             End If
          Next k
       Else
          Found = True
       End If
       ' Only send back Items found in Index Class list
       If Found Then
          ItemList(0, 0) = j
          j = j + 1
       End If
    Next i

VhlLstFldEnd:

    ' Free the objects
    Set ContentObj = Nothing
    Set FolderObj = Nothing

    ' Set return value to error code
    VbVhlListFolderItems = ulRC

    Exit Function

VhlLstFldError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlLstFldEnd

End Function

Function VbVhlListFolderItemsAttr (ItemList(), FolderId)

    ' Declarations
    Dim FolderObj As Object
    Dim ContentObj As Object
    Dim ulTOCCnt, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlLstFldAttrError
    ulRC = 0

    ' Get the Folder Object
    Set FolderObj = VhlApplObj.ItemID(FolderId)

    ' Setup return array based on size of folder
    ulTOCCnt = FolderObj.TOCCount
    ReDim ItemList(ulTOCCnt + 1, 4)
    ItemList(0, 0) = 0

    ' Get the list of Item Objects in the Folder
    For i = 1 To ulTOCCnt
       Set ContentObj = FolderObj.GetTOCItem(i - 1)
       ItemList(i, 1) = ContentObj.ItemID
       ItemList(i, 2) = ContentObj.Type
       ItemList(i, 3) = ContentObj.Class
       ItemList(0, 0) = i
       ItemList(i, 0) = 3

       ' Get the list of Index Class attributes
       strRet = VhlApplObj.ClassKeyFieldList(ContentObj.Class, ";")
       ulTotLen = Len(strRet)
       j = 3
       ulStart = 1
       ' Add attributes to List array
       Do
          ' Each name separated by a ";"
          ulEnd = InStr(ulStart, strRet, ";")
          If (ulEnd = 0) Then
             ulEnd = ulTotLen + 1
          End If
          ulLen = ulEnd - ulStart
          AttrName = Mid$(strRet, ulStart, ulLen)

          ' Set next array variables to attribute name and value
          j = j + 1
          ReDim Preserve ItemList(i, j + 2)
          ItemList(i, j) = AttrName
          j = j + 1
          ItemList(i, j) = ContentObj.KeyFields(AttrName)

          ' Setup for next loop
          ulStart = ulEnd + 1
       Loop Until (ulStart >= ulTotLen)

       ' Reset total number of variables in array
       ItemList(i, 0) = j
       ' Free the current Item object
       Set ContentObj = Nothing

    Next i

VhlLstFldAttrEnd:

    ' Free the objects
    Set ContentObj = Nothing
    Set FolderObj = Nothing

    ' Set return value to error code
    VbVhlListFolderItemsAttr = ulRC

    Exit Function

VhlLstFldAttrError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlLstFldAttrEnd

End Function

Function VbVhlListIndexClassAttr (AttrList(), ClassName)

    ' Declarations
    Dim i, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlClassAttrError
    ulRC = 0

    ' Get the list of Index Class attributes
    strRet = VhlApplObj.ClassKeyFieldList(ClassName, ";")
    ulTotLen = Len(strRet)

    ' Add attributes to List array
    i = 0
    ReDim AttrList(1)
    AttrList(0) = 0
    ulStart = 1
    Do
       ' Each name separated by a ";"
       ulEnd = InStr(ulStart, strRet, ";")
       If (ulEnd = 0) Then
          ulEnd = ulTotLen + 1
       End If
       ulLen = ulEnd - ulStart

       ' Set next array variable to attribute name
       i = i + 1
       ReDim Preserve AttrList(i + 1)
       AttrList(i) = Mid$(strRet, ulStart, ulLen)

       ' Setup for next loop
       ulStart = ulEnd + 1
    Loop Until (ulStart >= ulTotLen)

    ' Set total number of attributes in array
    AttrList(0) = i

VhlClassAttrEnd:

    ' Set return value to error code
    VbVhlListIndexClassAttr = ulRC

    Exit Function

VhlClassAttrError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlClassAttrEnd

End Function

Function VbVhlListIndexClasses (IxClassList())

    ' Declarations
    Dim i, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlClassListError
    ulRC = 0

    ' Get the list of Index Classes
    strRet = VhlApplObj.ClassList(";")
    ulTotLen = Len(strRet)

    ' Add Index classes to List array
    i = 0
    ReDim IxClassList(1)
    IxClassList(0) = 0
    ulStart = 1
    Do
       ' Each name separated by a ";"
       ulEnd = InStr(ulStart, strRet, ";")
       If (ulEnd = 0) Then
          ulEnd = ulTotLen + 1
       End If
       ulLen = ulEnd - ulStart

       ' Set next array variable to Index Class name
       i = i + 1
       ReDim Preserve IxClassList(i + 1)
       IxClassList(i) = Mid$(strRet, ulStart, ulLen)

       ' Setup for next loop
       ulStart = ulEnd + 1
    Loop Until (ulStart >= ulTotLen)

    ' Set total number of Index Classes in array
    IxClassList(0) = i

VhlClassListEnd:

    ' Set return value to error code
    VbVhlListIndexClasses = ulRC

    Exit Function

VhlClassListError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlClassListEnd

End Function

Function VbVhlListItemCC (ItemCC, ItemID, PartNum)

    ' Declarations
    Dim ItemObj As Object

    ' Setup Error handler
    On Error GoTo VhlItemCCError
    ulRC = 0

    ' Get the Item object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Copy content class of document base part
    ItemCC = ItemObj.GetPartContentClass(PartNum)

VhlItemCCEnd:

    ' Free the object
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlListItemCC = ulRC

    Exit Function

VhlItemCCError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlItemCCEnd

End Function

Function VbVhlListItemInfo (ItemList(), ItemID)

    ' Declarations
    Dim ItemObj As Object
    Dim ulTOCCnt, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlListInfoError
    ulRC = 0

    ' Get the Item Object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Get the list of Item Objects in the Folder
    ReDim ItemList(10)
    ItemList(0) = 3
    ItemList(1) = ItemObj.ItemID
    ItemList(2) = ItemObj.Type
    ItemList(3) = ItemObj.Class

    ' Workbaskets don't have attributes
    If ItemList(2) > 2 Then
       GoTo VhlListInfoEnd
    End If

    ' Get the list of Index Class attributes
    strRet = VhlApplObj.ClassKeyFieldList(ItemObj.Class, ";")
    ulTotLen = Len(strRet)
    i = 3
    ulStart = 1
    ' Add attributes to List array
    Do
       ' Each name separated by a ";"
       ulEnd = InStr(ulStart, strRet, ";")
       If (ulEnd = 0) Then
          ulEnd = ulTotLen + 1
       End If
       ulLen = ulEnd - ulStart
       AttrName = Mid$(strRet, ulStart, ulLen)

       ' Set next array variables to attribute name and value
       i = i + 1
       ReDim Preserve ItemList(i + 2)
       ItemList(i) = AttrName
       i = i + 1
       ItemList(i) = ItemObj.KeyFields(AttrName)

       ' Setup for next loop
       ulStart = ulEnd + 1
    Loop Until (ulStart >= ulTotLen)

    ' Set total number of variables in array
    ItemList(0) = i

VhlListInfoEnd:

    ' Free the objects
    Set ItemObj = Nothing

    ' Set return value to error code
    VbVhlListItemInfo = ulRC

    Exit Function

VhlListInfoError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlListInfoEnd

End Function

Function VbVhlListWBItems (ItemList(), WBItemID)

    ' Declarations
    Dim WBObj As Object
    Dim ContentObj As Object
    Dim ulTOCCnt As Long

    ' Setup Error handler
    On Error GoTo VhlLstWBItemError
    ulRC = 0

    ' Get the WB Object
    Set WBObj = VhlApplObj.GetWorkbasket(WBItemID)

    ' Setup return array based on size of WB
    ulTOCCnt = WBObj.TOCCount
    ReDim ItemList(ulTOCCnt + 1)
    ItemList(0) = 0

    ' Get the list of Item Objects in the WB
    j = 1
    For i = 1 To ulTOCCnt
       Set ContentObj = WBObj.GetTOCItem(i - 1)
       ItemList(j) = ContentObj.ItemID
       Set ContentObj = Nothing
       ItemList(0) = j
       j = j + 1
    Next i

VhlLstWBItemEnd:

    ' Free the objects
    Set ContentObj = Nothing
    Set WBObj = Nothing

    ' Set return value to error code
    VbVhlListWBItems = ulRC

    Exit Function

VhlLstWBItemError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlLstWBItemEnd

End Function

Function VbVhlListWorkBaskets (WBList())

    ' Declarations
    Dim i, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlListWBError
    ulRC = 0

    ' Get the list of WorkBaskets
    strRet = VhlApplObj.WorkBasketList(";")
    ulTotLen = Len(strRet)

    ' Add Index classes to List array
    i = 0
    ReDim WBList(1)
    WBList(0) = 0
    ulStart = 1
    Do
       ' Each name separated by a ";"
       ulEnd = InStr(ulStart, strRet, ";")
       If (ulEnd = 0) Then
          ulEnd = ulTotLen + 1
       End If
       ulLen = ulEnd - ulStart

       ' Set next array variable to Index Class name
       i = i + 1
       ReDim Preserve WBList(i + 1)
       WBList(i) = Mid$(strRet, ulStart, ulLen)

       ' Setup for next loop
       ulStart = ulEnd + 1
    Loop Until (ulStart >= ulTotLen)

    ' Set total number of Index Classes in array
    WBList(0) = i

VhlListWBEnd:

    ' Set return value to error code
    VbVhlListWorkBaskets = ulRC

    Exit Function

VhlListWBError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlListWBEnd

End Function

Function VbVhlLoadFuncs ()

    ' Setup Error handler
    On Error GoTo VhlLoadError
    ulRC = 0

    ' Get the application object
    Set VhlApplObj = CreateObject("Vic.Application")

    ' Setup Global Application Objects
    Set VhlDocsObj = VhlApplObj.Documents
    Set VhlErrorObj = VhlApplObj.Error

VhlLoadEnd:

    ' Set return value to error code
    VbVhlLoadFuncs = ulRC

    Exit Function

VhlLoadError:

    ' Set return code to error code
    ulRC = Err
    Resume VhlLoadEnd

End Function

Function VbVhlLogoff ()

    ' Setup Error handler
    On Error GoTo VhlLogoffError

    ' Logoff from VisualInfo
    ulRC = 0
    VhlApplObj.Quit
    Set VhlDocsObj = Nothing
    Set VhlErrorObj = Nothing
    Set VhlApplObj = Nothing

VhlLogoffEnd:

    ' Set return value to error code
    VbVhlLogoff = ulRC

    Exit Function

VhlLogoffError:

    ' Set return code to error code
    ulRC = Err
    Resume VhlLogoffEnd

End Function

Function VbVhlLogon (UserId, Password, LibServer)

    ' Setup Error handler
    On Error GoTo VhlLogonError
    ulRC = 0

    ' Get the application object
    Set VhlApplObj = CreateObject("Vic.Application")

    ' Set logon information
    VhlApplObj.User = UserId
    VhlApplObj.Server = LibServer
    VhlApplObj.Password = Password

    ' Display the Logon screen and Log onto VisualInfo
    ulRC = VhlApplObj.Logon
    If (ulRC = 0) Then
       ' Setup Global Application Objects
       Set VhlDocsObj = VhlApplObj.Documents
       Set VhlErrorObj = VhlApplObj.Error
    Else
       ' Release application object
       Set VhlApplObj = Nothing
    End If

VhlLogonEnd:

    ' Set return value to error code
    VbVhlLogon = ulRC

    Exit Function

VhlLogonError:

    ' Set return code to error code
    ulRC = Err
    Resume VhlLogonEnd

End Function

Function VbVhlRemoveFolderItem (ItemID, FolderId)

    ' Declarations
    Dim ItemObj As Object
    Dim FolderObj As Object

    ' Setup Error handler
    On Error GoTo VhlRemFolderError
    ulRC = 0

    ' Get the Folder Object
    Set FolderObj = VhlApplObj.ItemID(FolderId)

    ' Get the ItemID Object
    Set ItemObj = VhlApplObj.ItemID(ItemID)

    ' Put ItemId into Folder
    ulRC = ItemObj.RemoveFromFolder(FolderObj)

VhlRemFolderEnd:

    ' Free the objects
    Set ItemObj = Nothing
    Set FolderObj = Nothing

    ' Set return value to error code
    VbVhlRemoveFolderItem = ulRC

    Exit Function

VhlRemFolderError:

    ' Set return value to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlRemFolderEnd

End Function

Function VbVhlScanDoc ()

    ' Setup Error handler
    On Error GoTo VhlScanDocError
    ulRC = 0

    ' Scan some documents
    VhlApplObj.OpenScan

VhlScanDocEnd:

    Exit Function

VhlScanDocError:

    ' Set return code to error code
    VbVhlScanDoc = VhlErrorObj.ReturnCode

    Resume VhlScanDocEnd

End Function

Function VbVhlSearchAdv (ItemList(), ClassName, Criteria, TypeFilter, WIPFilter, SuspendFilter)

    ' Declarations
    Dim FolderObj As Object
    Dim ContentObj As Object
    Dim ulTOCCnt, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlSearchAdvError
    ulRC = 0

    ' Get the search results folder
    Set FolderObj = VhlApplObj.Search(ClassName, Criteria, TypeFilter, WIPFilter, SuspendFilter)

    ' If only 1 match - then actual Item returned NOT a Folder
    If FolderObj.Class <> "" Then
       ReDim ItemList(2)
       ItemList(0) = 1
       ItemList(1) = FolderObj.ItemID
       GoTo VhlSearchAdvEnd
    End If

    ' Setup return array based on size of folder
    ulTOCCnt = FolderObj.TOCCount
    ReDim ItemList(ulTOCCnt + 1)
    ItemList(0) = 0

    ' Get the list of Item Objects in the Folder
    For i = 1 To ulTOCCnt
       Set ContentObj = FolderObj.GetTOCItem(i - 1)
       ItemList(i) = ContentObj.ItemID
       Set ContentObj = Nothing
       ItemList(0) = i
    Next

VhlSearchAdvEnd:

    ' Free the objects
    Set ContentObj = Nothing
    Set FolderObj = Nothing

    ' Set return value to error code
    VbVhlSearchAdv = ulRC

    Exit Function

VhlSearchAdvError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlSearchAdvEnd

End Function

Function VbVhlSearchItem (ItemList(), ClassName, Criteria)

    ' Declarations
    Dim FolderObj As Object
    Dim ContentObj As Object
    Dim ulTOCCnt, ulStart, ulEnd, ulLen, ulTotLen As Long

    ' Setup Error handler
    On Error GoTo VhlSearchError
    ulRC = 0

    ' Get the search results folder
    Set FolderObj = VhlApplObj.Search(ClassName, Criteria, 3, 15, 3)

    ' If only 1 match - then actual Item returned NOT a Folder
    If FolderObj.Class <> "" Then
       ReDim ItemList(2)
       ItemList(0) = 1
       ItemList(1) = FolderObj.ItemID
       GoTo VhlSearchEnd
    End If

    ' Setup return array based on size of folder
    ulTOCCnt = FolderObj.TOCCount
    ReDim ItemList(ulTOCCnt + 1)
    ItemList(0) = 0

    ' Get the list of Item Objects in the Folder
    For i = 1 To ulTOCCnt
       Set ContentObj = FolderObj.GetTOCItem(i - 1)
       ItemList(i) = ContentObj.ItemID
       Set ContentObj = Nothing
       ItemList(0) = i
    Next

VhlSearchEnd:

    ' Free the objects
    Set ContentObj = Nothing
    Set FolderObj = Nothing

    ' Set return value to error code
    VbVhlSearchItem = ulRC

    Exit Function

VhlSearchError:

    ' Set return code to error code
    ulRC = VhlErrorObj.ReturnCode

    Resume VhlSearchEnd

End Function

